/*
 * WiPal - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef PCAP_LIST_OF_TRACES_HH_
# define PCAP_LIST_OF_TRACES_HH_

# include <wipal/tool/list_of_iterables.hh>
# include <wipal/pcap/descriptor.hh>

namespace pcapxx
{

  template <class Desc = descriptor<>, class Bottom = tool::bottom>
  struct list_of_traces:
    public tool::list_of_iterables<Desc,
				   wp_get_exact(Bottom,
						list_of_traces<Desc, Bottom>)>
  {
    typedef wp_get_exact(Bottom, list_of_traces<Desc, Bottom>)	exact_type;
    typedef tool::list_of_iterables<Desc, exact_type>		super_type;

    list_of_traces(const std::string& trace_names = "",
		   const std::string& separators = ":");

    const std::string&	file_name() const;
    void		expect(typename Desc::link_type l) const;

  private:
    std::string	name_;
  };

} // End of namespace pcapxx.

namespace tool
{

  template <class Desc, class Bottom>
  struct types< pcapxx::list_of_traces<Desc, Bottom> >:
    public types< list_of_iterables<Desc,
				    wp_get_exact(Bottom,
						 pcapxx::list_of_traces<Desc,
								    Bottom>)> >
  {
  };

} // End of namespace tool.

# include "list_of_traces.hxx"

#endif // ! PCAP_LIST_OF_TRACES_HH_
