/*
 * WiPal - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef TOOL_ITERATOR_HXX_
# define TOOL_ITERATOR_HXX_

# include "iterator.hh"

namespace tool
{

  template <class B>
  bool
  iterator<B>::operator == (const exact_type& rhs) const
  {
    return this->exact().equal(rhs.exact());
  }

  template <class B>
  bool
  iterator<B>::operator != (const exact_type& rhs) const
  {
    return not (*this == rhs);
  }

  template <class B>
  const typename iterator<B>::exact_type&
  iterator<B>::operator ++ ()
  {
    this->exact().increment();
    return this->exact();
  }

  template <class B>
  typename iterator<B>::exact_type
  iterator<B>::operator ++ (int)
  {
    exact_type r = this->exact();
    ++(*this);
    return r;
  }

  template <class B>
  const typename iterator<B>::value_type&
  iterator<B>::operator * () const
  {
    return this->exact().get();
  }

  template <class B>
  const typename iterator<B>::value_type*
  iterator<B>::operator -> () const
  {
    return this->exact().get_ptr();
  }

  template <class B>
  iterator<B>::~iterator()
  {
  }

} // End of namespace tool.

#endif // ! TOOL_ITERATOR_HXX_
